CVE-2021-31535

critical
New! CVE Severity Now Using CVSS v3

The calculated severity for CVEs has been updated to use CVSS v3 by default. CVEs that do not have a CVSS v3 score will fall back CVSS v2 for calculating severity. Severity display preferences can be toggled in the settings dropdown.

Description

LookupCol.c in X.Org X through X11R7.7 and libX11 before 1.7.1 might allow remote attackers to execute arbitrary code. The libX11 XLookupColor request (intended for server-side color lookup) contains a flaw allowing a client to send color-name requests with a name longer than the maximum size allowed by the protocol (and also longer than the maximum packet size for normal-sized packets). The user-controlled data exceeding the maximum size is then interpreted by the server as additional X protocol requests and executed, e.g., to disable X server authorization completely. For example, if the victim encounters malicious terminal control sequences for color codes, then the attacker may be able to take full control of the running graphical session.

References

https://unparalleled.eu/blog/2021/20210518-using-xterm-to-navigate-the-huge-color-space/

https://unparalleled.eu/publications/2021/advisory-unpar-2021-1.txt

https://lists.freedesktop.org/archives/xorg/

https://www.openwall.com/lists/oss-security/2021/05/18/2

https://www.openwall.com/lists/oss-security/2021/05/18/3

https://lists.x.org/archives/xorg-announce/2021-May/003088.html

https://lists.debian.org/debian-lts-announce/2021/05/msg00021.html

http://packetstormsecurity.com/files/162737/libX11-Insufficient-Length-Check-Injection.html

https://www.debian.org/security/2021/dsa-4920

http://www.openwall.com/lists/oss-security/2021/05/18/2

https://security.gentoo.org/glsa/202105-16

http://seclists.org/fulldisclosure/2021/May/52

https://gitlab.freedesktop.org/xorg/lib/libx11/-/commit/8d2e02ae650f00c4a53deb625211a0527126c605

https://security.netapp.com/advisory/ntap-20210813-0001/

https://lists.fedoraproject.org/archives/list/[email protected]/message/TEOT4RLB76RVPJQKGGTIKTBIOLHX2NR6/

https://lists.apache.org/thread.html/[email protected]%3Cusers.kafka.apache.org%3E

https://lists.apache.org/thread.html/[email protected]%3Cdev.kafka.apache.org%3E

https://lists.apache.org/thread.html/[email protected]%3Cusers.kafka.apache.org%3E

https://lists.apache.org/thread.html/[email protected]%3Cdev.kafka.apache.org%3E

Details

Source: MITRE

Published: 2021-05-27

Updated: 2021-09-23

Type: CWE-120

Risk Information

CVSS v2

Base Score: 7.5

Vector: AV:N/AC:L/Au:N/C:P/I:P/A:P

Impact Score: 6.4

Exploitability Score: 10

Severity: HIGH

CVSS v3

Base Score: 9.8

Vector: CVSS:3.1/AV:N/AC:L/PR:N/UI:N/S:U/C:H/I:H/A:H

Impact Score: 5.9

Exploitability Score: 3.9

Severity: CRITICAL

Vulnerable Software

Configuration 1

OR

cpe:2.3:a:x.org:libx11:*:*:*:*:*:*:*:*

cpe:2.3:o:x.org:x_window_system:*:*:*:*:*:*:*:* versions up to x11r7.7 (inclusive)

Configuration 2

OR

cpe:2.3:o:fedoraproject:fedora:33:*:*:*:*:*:*:*

Tenable Plugins

View all (25 total)

IDNameProductFamilySeverity
153708EulerOS 2.0 SP5 : libX11 (EulerOS-SA-2021-2507)NessusHuawei Local Security Checks
critical
153707EulerOS 2.0 SP9 : libX11 (EulerOS-SA-2021-2558)NessusHuawei Local Security Checks
critical
153686EulerOS 2.0 SP9 : libX11 (EulerOS-SA-2021-2534)NessusHuawei Local Security Checks
critical
153609EulerOS 2.0 SP8 : libX11 (EulerOS-SA-2021-2472)NessusHuawei Local Security Checks
critical
153347EulerOS 2.0 SP2 : libX11 (EulerOS-SA-2021-2405)NessusHuawei Local Security Checks
critical
152946Scientific Linux Security Update : libX11 on SL7.x i686/x86_64 (2021:3296)NessusScientific Linux Local Security Checks
critical
152909CentOS 7 : libX11 (CESA-2021:3296)NessusCentOS Local Security Checks
critical
152907Oracle Linux 7 : libX11 (ELSA-2021-3296)NessusOracle Linux Local Security Checks
critical
152906RHEL 7 : libX11 (RHSA-2021:3296)NessusRed Hat Local Security Checks
critical
151795Amazon Linux 2 : libX11 (ALAS-2021-1686)NessusAmazon Linux Local Security Checks
critical
151749openSUSE 15 Security Update : libX11 (openSUSE-SU-2021:1897-1)NessusSuSE Local Security Checks
critical
151511Amazon Linux AMI : libX11 (ALAS-2021-1517)NessusAmazon Linux Local Security Checks
critical
150874SUSE SLES11 Security Update : xorg-x11-libX11 (SUSE-SU-2021:14748-1)NessusSuSE Local Security Checks
critical
150457openSUSE Security Update : libX11 (openSUSE-2021-857)NessusSuSE Local Security Checks
critical
150415SUSE SLED15 / SLES15 Security Update : libX11 (SUSE-SU-2021:1897-1)NessusSuSE Local Security Checks
high
150406SUSE SLED12 / SLES12 Security Update : libX11 (SUSE-SU-2021:1892-1)NessusSuSE Local Security Checks
high
150171FreeBSD : libX11 -- Arbitrary code execution (58d6ed66-c2e8-11eb-9fb0-6451062f0f7a)NessusFreeBSD Local Security Checks
critical
150087openSUSE Security Update : libX11 (openSUSE-2021-807)NessusSuSE Local Security Checks
critical
150018SUSE SLED15 / SLES15 Security Update : libX11 (SUSE-SU-2021:1765-1)NessusSuSE Local Security Checks
critical
150012SUSE SLES12 Security Update : libX11 (SUSE-SU-2021:1766-1)NessusSuSE Local Security Checks
critical
149905Ubuntu 16.04 LTS : libx11 vulnerability (USN-4966-2)NessusUbuntu Local Security Checks
critical
149903Ubuntu 18.04 LTS / 20.04 LTS / 20.10 / 21.04 : libx11 vulnerability (USN-4966-1)NessusUbuntu Local Security Checks
critical
149897Debian DSA-4920-1 : libx11 - security updateNessusDebian Local Security Checks
critical
149889Debian DLA-2666-1 : libx11 security updateNessusDebian Local Security Checks
critical
149799Slackware 14.0 / 14.1 / 14.2 / current : libX11 (SSA:2021-139-01)NessusSlackware Local Security Checks
critical